"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.QueryBuilderFactory = void 0;
const tslib_1 = require("tslib");
const profile_1 = require("./profile");
class QueryBuilderFactory {
    constructor() {
        this.profileFactory = new profile_1.ProfileLoader();
    }
    build(adapter, profileType) {
        return tslib_1.__awaiter(this, void 0, void 0, function* () {
            const profile = this.profileFactory.load(profileType);
            switch (adapter) {
                case 'typeorm':
                    const qb = (yield Promise.resolve().then(() => require('./typeorm/query-builder')))
                        .TypeORMQueryBuilder;
                    return new qb(profile);
                default:
                    throw new Error(`No adapter found for ${adapter}`);
            }
        });
    }
}
exports.QueryBuilderFactory = QueryBuilderFactory;
//# sourceMappingURL=factory.js.map