"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FieldFilter = void 0;
const lookup_builder_factory_1 = require("./lookup-builder-factory");
const typeorm_1 = require("typeorm");
const filter_1 = require("../filter");
class FieldFilter extends filter_1.AbstractFilter {
    constructor(config) {
        super(config.query, config.prop, config.lookup, config.value);
        this.lookupBuilderFactory = new lookup_builder_factory_1.LookupBuilderFactory();
        this.notOperator = config.notOperator || false;
    }
    buildQuery() {
        const queryToAdd = this.getQuery();
        this.setQuery(queryToAdd);
    }
    setQuery(queryToAdd) {
        this.query['where'] = Object.assign(Object.assign({}, this.query['where']), queryToAdd);
    }
    getQuery() {
        const builder = this.lookupBuilderFactory.build(this.lookup);
        const queryToAdd = builder.build(this.prop, this.value);
        if (this.notOperator) {
            queryToAdd[this.prop] = (0, typeorm_1.Not)(queryToAdd[this.prop]);
        }
        return queryToAdd;
    }
}
exports.FieldFilter = FieldFilter;
//# sourceMappingURL=field-filter.js.map