"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TypeORMQueryBuilder = void 0;
const filter_factory_1 = require("./filter/filter-factory");
const container_1 = require("./filter/options/container");
const query_builder_1 = require("../query-builder");
class TypeORMQueryBuilder extends query_builder_1.QueryBuilder {
    constructor(profile) {
        super(profile);
        this.findOptions = new container_1.OptionsCollection();
        this.filterFactory = new filter_factory_1.FilterFactory();
    }
    build(expressQuery) {
        const typeORMQuery = {};
        for (const option of this.findOptions.options) {
            option.setOption({
                source: expressQuery,
                target: typeORMQuery,
            }, this.profile);
        }
        for (const queryItem in expressQuery) {
            const filter = this.filterFactory.get({
                query: typeORMQuery,
                key: queryItem,
                value: expressQuery[queryItem],
            });
            filter.buildQuery();
        }
        return typeORMQuery;
    }
}
exports.TypeORMQueryBuilder = TypeORMQueryBuilder;
//# sourceMappingURL=query-builder.js.map